OGRE: Ogre::TextureManager Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::TextureManager Class Referenceabstract
Core » Resources

Class for loading & managing textures. More...

`#include <OgreTextureManager.h>`

Inheritance diagram for Ogre::TextureManager:
[legend]

## Public Member Functions
| TextureManager (void)
virtual | ~TextureManager ()
const TexturePtr & | _getWarningTexture ()
| Internal method to create a warning texture (bound when a texture unit is blank).
TexturePtr | create (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new texture.
TexturePtr | createManual (const String &name, const String &group, TextureType texType, uint width, uint height, int numMipmaps, PixelFormat format, int usage=TU_DEFAULT, ManualResourceLoader *loader=0, bool hwGammaCorrection=false, uint fsaa=0, const String &fsaaHint=BLANKSTRING)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual TexturePtr | createManual (const String &name, const String &group, TextureType texType, uint width, uint height, uint depth, int numMipmaps, PixelFormat format, int usage=TU_DEFAULT, ManualResourceLoader *loader=0, bool hwGammaCorrection=false, uint fsaa=0, const String &fsaaHint=BLANKSTRING)
| Create a manual texture with specified width, height and depth (not loaded from a file).
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual, ManualResourceLoader *loader, const NameValuePairList *createParams, TextureType texType, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, bool isAlpha=false, PixelFormat desiredFormat=PF_UNKNOWN, bool hwGammaCorrection=false)
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
SamplerPtr | createSampler (const String &name=BLANKSTRING)
| create a new sampler
TexturePtr | getByName (const String &name, const String &groupName=RGN_DEFAULT) const
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
virtual uint32 | getDefaultNumMipmaps ()
| Gets the default number of mipmaps to be used for loaded textures.
const SamplerPtr & | getDefaultSampler ()
| get the default sampler
virtual PixelFormat | getNativeFormat (TextureType ttype, PixelFormat format, int usage)=0
| Gets the format which will be natively used for a requested format given the constraints of the current device.
virtual ushort | getPreferredFloatBitDepth (void) const
| Gets preferred bit depth for float pixel format textures.
virtual ushort | getPreferredIntegerBitDepth (void) const
| Gets preferred bit depth for integer pixel format textures.
const SamplerPtr & | getSampler (const String &name) const
| retrieve an named sampler
virtual bool | isEquivalentFormatSupported (TextureType ttype, PixelFormat format, int usage)
| Returns whether this render system can support the texture format requested with the given usage options, or another format with no quality reduction.
virtual bool | isFormatSupported (TextureType ttype, PixelFormat format, int usage)
| Returns whether this render system can natively support the precise texture format requested with the given usage options.
virtual bool | isHardwareFilteringSupported (TextureType ttype, PixelFormat format, int usage, bool preciseFormatOnly=false)
| Returns whether this render system has hardware filtering supported for the texture format requested with the given usage options.
TexturePtr | load (const String &name, const String &group, TextureType texType, int numMipmaps, Real gamma, bool isAlpha, PixelFormat desiredFormat=PF_UNKNOWN, bool hwGammaCorrection=false)
TexturePtr | load (const String &name, const String &group, TextureType texType=TEX_TYPE_2D, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, PixelFormat desiredFormat=PF_UNKNOWN, bool hwGammaCorrection=false)
| Loads a texture from a file.
virtual TexturePtr | loadImage (const String &name, const String &group, const Image &img, TextureType texType=TEX_TYPE_2D, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, bool isAlpha=false, PixelFormat desiredFormat=PF_UNKNOWN, bool hwGammaCorrection=false)
| Loads a texture from an Image object.
virtual TexturePtr | loadRawData (const String &name, const String &group, DataStreamPtr &stream, ushort width, ushort height, PixelFormat format, TextureType texType=TEX_TYPE_2D, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, bool hwGammaCorrection=false)
| Loads a texture from a raw data stream.
TexturePtr | prepare (const String &name, const String &group, TextureType texType=TEX_TYPE_2D, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, bool isAlpha=false, PixelFormat desiredFormat=PF_UNKNOWN, bool hwGammaCorrection=false)
| Prepares to loads a texture from a file.
void | removeAllNamedSamplers ()
| clear the list of named samplers
virtual void | setDefaultNumMipmaps (uint32 num)
| Sets the default number of mipmaps to be used for loaded textures, for when textures are loaded automatically (e.g.
virtual void | setPreferredBitDepths (ushort integerBits, ushort floatBits, bool reloadTextures=true)
| Sets preferred bit depth for integer and float pixel format.
virtual void | setPreferredFloatBitDepth (ushort bits, bool reloadTextures=true)
| Sets preferred bit depth for float pixel format textures.
virtual void | setPreferredIntegerBitDepth (ushort bits, bool reloadTextures=true)
| Sets preferred bit depth for integer pixel format textures.
Public Member Functions inherited from Ogre::ResourceManager
| ResourceManager ()
virtual | ~ResourceManager ()
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle) const
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder (void) const override
| Gets the loading order for scripts of this type.
size_t | getMemoryBudget (void) const
| Get the limit on the amount of memory this resource handler may use.
size_t | getMemoryUsage (void) const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=RGN_DEFAULT) const
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator (void)
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType (void) const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns (void) const override
| Gets the file patterns which should be used to find scripts for this class.
bool | getVerbose (void)
| Gets whether this manager and its resources habitually produce log output.
ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse a script file.
ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
void | remove (const ResourcePtr &r)
| Remove a single resource.
void | remove (const String &name, const String &group=RGN_DEFAULT)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | remove (ResourceHandle handle)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | removeAll (void)
| Removes all resources.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
bool | resourceExists (const String &name, const String &group=RGN_DEFAULT) const
| Returns whether the named resource exists in this manager.
bool | resourceExists (ResourceHandle handle) const
| Returns whether a resource with the given handle exists in this manager.
void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
void | unload (const String &name, const String &group=RGN_DEFAULT)
| Unloads a single resource by name.
void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()
Public Member Functions inherited from Ogre::Singleton< TextureManager >
| ~Singleton (void)

## Static Public Member Functions
static TextureManager & | getSingleton (void)
| Get the singleton instance.
static TextureManager * | getSingletonPtr (void)
| Get the singleton instance.
Static Public Member Functions inherited from Ogre::Singleton< TextureManager >
static TextureManager & | getSingleton (void)
| Get the singleton instance.
static TextureManager * | getSingletonPtr (void)
| Get the singleton instance.

## Additional Inherited Members
Public Types inherited from Ogre::ResourceManager
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef std::map< ResourceHandle, ResourcePtr > | ResourceHandleMap
typedef std::unordered_map< String, ResourcePtr > | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef std::unordered_map< String, ResourceMap > | ResourceWithGroupMap

## Detailed Description

Class for loading & managing textures.

Note that this class is abstract - the particular RenderSystem that is in use at the time will create a concrete subclass of this. Note that the concrete class will be available via the abstract singleton obtained from TextureManager::getSingleton(), but you should not assume that it is available until you have a) initialised Ogre (after selecting a RenderSystem and calling initialise from the Root object), and b) created at least one window - this may be done at the same time as part a if you allow Ogre to autocreate one.

## Constructor & Destructor Documentation

## ◆ TextureManager()

Ogre::TextureManager::TextureManager | ( | void |  | ) |

Referenced by getSingleton(), and getSingletonPtr().

## ◆ ~TextureManager()

virtual Ogre::TextureManager::~TextureManager | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ createSampler()

SamplerPtr Ogre::TextureManager::createSampler | ( | const String & | name = BLANKSTRING | ) |

create a new sampler

References Ogre::BLANKSTRING.

## ◆ getSampler()

const SamplerPtr & Ogre::TextureManager::getSampler | ( | const String & | name | ) | const

retrieve an named sampler

## ◆ removeAllNamedSamplers()

void Ogre::TextureManager::removeAllNamedSamplers | ( |  | ) |
| inline

clear the list of named samplers

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to these resources, they will persist until they have been finished with; however to all intents and purposes the resources no longer exist and will get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ create()

TexturePtr Ogre::TextureManager::create | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )

Create a new texture.

Parameters

  name | The unique name of the Resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs

## ◆ getByName()

TexturePtr Ogre::TextureManager::getByName | ( | const String & | name,
|  | const String & | groupName = RGN_DEFAULT ) const

Retrieves a pointer to a resource by name, or null if the resource does not exist.

References Ogre::ResourceManager::createOrRetrieve(), and OGRE_RESOURCE_GROUP_INIT.

## ◆ createOrRetrieve() [1/2]

ResourceCreateOrRetrieveResult Ogre::TextureManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual,
|  | ManualResourceLoader * | loader,
|  | const NameValuePairList * | createParams,
|  | TextureType | texType,
|  | int | numMipmaps = MIP_DEFAULT,
|  | Real | gamma = 1.0f,
|  | bool | isAlpha = false,
|  | PixelFormat | desiredFormat = PF_UNKNOWN,
|  | bool | hwGammaCorrection = false )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  name | The unique name of the Resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs
  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening)
  isAlpha | deprecated: same as specifying PF_A8 for `desiredFormat`
  desiredFormat | The format you would like to have used instead of the format being based on the contents of the texture
  hwGammaCorrection | Pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.

References Ogre::MIP_DEFAULT, and Ogre::PF_UNKNOWN.

## ◆ prepare()

TexturePtr Ogre::TextureManager::prepare | ( | const String & | name,
|  | const String & | group,
|  | TextureType | texType = TEX_TYPE_2D,
|  | int | numMipmaps = MIP_DEFAULT,
|  | Real | gamma = 1.0f,
|  | bool | isAlpha = false,
|  | PixelFormat | desiredFormat = PF_UNKNOWN,
|  | bool | hwGammaCorrection = false )

Prepares to loads a texture from a file.

Parameters

  name | The file to load, or a String identifier in some cases
  group | The name of the resource group to assign the texture to
  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening)
  desiredFormat | The format you would like to have used instead of the format being based on the contents of the texture; the manager reserves the right to create a different format for the texture if the original format is not available in this context.
  hwGammaCorrection | pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.
  isAlpha | deprecated: same as specifying PF_A8 for `desiredFormat`

References Ogre::MIP_DEFAULT, Ogre::PF_UNKNOWN, and Ogre::TEX_TYPE_2D.

## ◆ load() [1/2]

TexturePtr Ogre::TextureManager::load | ( | const String & | name,
|  | const String & | group,
|  | TextureType | texType = TEX_TYPE_2D,
|  | int | numMipmaps = MIP_DEFAULT,
|  | Real | gamma = 1.0f,
|  | PixelFormat | desiredFormat = PF_UNKNOWN,
|  | bool | hwGammaCorrection = false )

Loads a texture from a file.

Parameters

  name | The file to load, or a String identifier in some cases
  group | The name of the resource group to assign the texture to
  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening)
  desiredFormat | The format you would like to have used instead of the format being based on the contents of the texture; the manager reserves the right to create a different format for the texture if the original format is not available in this context.
  hwGammaCorrection | pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.

References Ogre::MIP_DEFAULT, Ogre::PF_UNKNOWN, and Ogre::TEX_TYPE_2D.

## ◆ load() [2/2]

TexturePtr Ogre::TextureManager::load | ( | const String & | name,
|  | const String & | group,
|  | TextureType | texType,
|  | int | numMipmaps,
|  | Real | gamma,
|  | bool | isAlpha,
|  | PixelFormat | desiredFormat = PF_UNKNOWN,
|  | bool | hwGammaCorrection = false )

Deprecated

References Ogre::PF_UNKNOWN.

## ◆ loadImage()

virtual TexturePtr Ogre::TextureManager::loadImage | ( | const String & | name,
|  | const String & | group,
|  | const Image & | img,
|  | TextureType | texType = TEX_TYPE_2D,
|  | int | numMipmaps = MIP_DEFAULT,
|  | Real | gamma = 1.0f,
|  | bool | isAlpha = false,
|  | PixelFormat | desiredFormat = PF_UNKNOWN,
|  | bool | hwGammaCorrection = false )
| virtual

Loads a texture from an Image object.

Note
  The texture will create as manual texture without loader.

Parameters

  name | The file to load, or a String identifier in some cases
  group | The name of the resource group to assign the texture to
  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening)
  desiredFormat | The format you would like to have used instead of the format being based on the contents of the texture; the manager reserves the right to create a different format for the texture if the original format is not available in this context.
  hwGammaCorrection | pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.
  isAlpha | deprecated: same as specifying PF_A8 for `desiredFormat`
  img | The Image object which contains the data to load

References Ogre::MIP_DEFAULT, Ogre::PF_UNKNOWN, and Ogre::TEX_TYPE_2D.

## ◆ loadRawData()

virtual TexturePtr Ogre::TextureManager::loadRawData | ( | const String & | name,
|  | const String & | group,
|  | DataStreamPtr & | stream,
|  | ushort | width,
|  | ushort | height,
|  | PixelFormat | format,
|  | TextureType | texType = TEX_TYPE_2D,
|  | int | numMipmaps = MIP_DEFAULT,
|  | Real | gamma = 1.0f,
|  | bool | hwGammaCorrection = false )
| virtual

Loads a texture from a raw data stream.

Note
  The texture will create as manual texture without loader.

Parameters

  name | The name to give the resulting texture
  group | The name of the resource group to assign the texture to
  stream | Incoming data stream
  width | The width of the texture
  height | The height of the texture
  format | The format of the data being passed in; the manager reserves the right to create a different format for the texture if the original format is not available in this context.
  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening) while loading
  hwGammaCorrection | Pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.

References Ogre::MIP_DEFAULT, and Ogre::TEX_TYPE_2D.

## ◆ createManual() [1/2]

virtual TexturePtr Ogre::TextureManager::createManual | ( | const String & | name,
|  | const String & | group,
|  | TextureType | texType,
|  | uint | width,
|  | uint | height,
|  | uint | depth,
|  | int | numMipmaps,
|  | PixelFormat | format,
|  | int | usage = TU_DEFAULT,
|  | ManualResourceLoader * | loader = 0,
|  | bool | hwGammaCorrection = false,
|  | uint | fsaa = 0,
|  | const String & | fsaaHint = BLANKSTRING )
| virtual

Create a manual texture with specified width, height and depth (not loaded from a file).

Parameters

  name | The name to give the resulting texture
  group | The name of the resource group to assign the texture to
  texType | The type of texture to load/create, defaults to normal 2D textures
  width | The width of the texture
  height | The height of the texture
  depth | The depth of the texture
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  format | The internal format you wish to request; the manager reserves the right to create a different format if the one you select is not available in this context.
  usage | The kind of usage this texture is intended for. It is a combination of TU_STATIC, TU_DYNAMIC, TU_WRITE_ONLY, TU_AUTOMIPMAP and TU_RENDERTARGET (see TextureUsage enum). You are strongly advised to use HBU_GPU_ONLY wherever possible, if you need to update regularly, consider HBU_CPU_TO_GPU.
  loader | If you intend the contents of the manual texture to be regularly updated, to the extent that you don't need to recover the contents if the texture content is lost somehow, you can leave this parameter as 0. However, if you intend to populate the texture only once, then you should implement ManualResourceLoader and pass a pointer to it in this parameter; this means that if the manual texture ever needs to be reloaded, the ManualResourceLoader will be called to do it.
  hwGammaCorrection | pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.
  fsaa | The level of multisampling to use if this is a render target. Ignored if usage does not include TU_RENDERTARGET or if the device does not support it.
  fsaaHint | RenderSystem specific FSAA option. See RenderSystem::_createRenderWindow for details.

References Ogre::BLANKSTRING, and Ogre::TU_DEFAULT.

Referenced by createManual().

## ◆ createManual() [2/2]

TexturePtr Ogre::TextureManager::createManual | ( | const String & | name,
|  | const String & | group,
|  | TextureType | texType,
|  | uint | width,
|  | uint | height,
|  | int | numMipmaps,
|  | PixelFormat | format,
|  | int | usage = TU_DEFAULT,
|  | ManualResourceLoader * | loader = 0,
|  | bool | hwGammaCorrection = false,
|  | uint | fsaa = 0,
|  | const String & | fsaaHint = BLANKSTRING )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References Ogre::BLANKSTRING, createManual(), and Ogre::TU_DEFAULT.

## ◆ setPreferredIntegerBitDepth()

virtual void Ogre::TextureManager::setPreferredIntegerBitDepth | ( | ushort | bits,
|  | bool | reloadTextures = true )
| virtual

Sets preferred bit depth for integer pixel format textures.

Parameters

  bits | Number of bits. Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for the pixel.
  reloadTextures | If true (the default), will reloading all reloadable textures.

## ◆ getPreferredIntegerBitDepth()

virtual ushort Ogre::TextureManager::getPreferredIntegerBitDepth | ( | void |  | ) | const
| virtual

Gets preferred bit depth for integer pixel format textures.

## ◆ setPreferredFloatBitDepth()

virtual void Ogre::TextureManager::setPreferredFloatBitDepth | ( | ushort | bits,
|  | bool | reloadTextures = true )
| virtual

Sets preferred bit depth for float pixel format textures.

Parameters

  bits | Number of bits. Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for a channel of the pixel.
  reloadTextures | If true (the default), will reloading all reloadable textures.

## ◆ getPreferredFloatBitDepth()

virtual ushort Ogre::TextureManager::getPreferredFloatBitDepth | ( | void |  | ) | const
| virtual

Gets preferred bit depth for float pixel format textures.

## ◆ setPreferredBitDepths()

virtual void Ogre::TextureManager::setPreferredBitDepths | ( | ushort | integerBits,
|  | ushort | floatBits,
|  | bool | reloadTextures = true )
| virtual

Sets preferred bit depth for integer and float pixel format.

Parameters

  integerBits | Number of bits. Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for the pixel.
  floatBits | Number of bits. Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for a channel of the pixel.
  reloadTextures | If true (the default), will reloading all reloadable textures.

## ◆ isFormatSupported()

virtual bool Ogre::TextureManager::isFormatSupported | ( | TextureType | ttype,
|  | PixelFormat | format,
|  | int | usage )
| virtual

Returns whether this render system can natively support the precise texture format requested with the given usage options.

You can still create textures with this format even if this method returns false; the texture format will just be altered to one which the device does support.

Note
  Sometimes the device may just slightly change the format, such as reordering the channels or packing the channels differently, without it making and qualitative differences to the texture. If you want to just detect whether the quality of a given texture will be reduced, use isEquivalentFormatSupport instead.

Parameters

  ttype | The type of texture
  format | The pixel format requested
  usage | The kind of usage this texture is intended for, a combination of the TextureUsage flags.

Returns
  true if the format is natively supported, false if a fallback would be used.

## ◆ isEquivalentFormatSupported()

virtual bool Ogre::TextureManager::isEquivalentFormatSupported | ( | TextureType | ttype,
|  | PixelFormat | format,
|  | int | usage )
| virtual

Returns whether this render system can support the texture format requested with the given usage options, or another format with no quality reduction.

## ◆ getNativeFormat()

virtual PixelFormat Ogre::TextureManager::getNativeFormat | ( | TextureType | ttype,
|  | PixelFormat | format,
|  | int | usage )
| pure virtual

Gets the format which will be natively used for a requested format given the constraints of the current device.

Implemented in Ogre::DefaultTextureManager.

## ◆ isHardwareFilteringSupported()

virtual bool Ogre::TextureManager::isHardwareFilteringSupported | ( | TextureType | ttype,
|  | PixelFormat | format,
|  | int | usage,
|  | bool | preciseFormatOnly = false )
| virtual

Returns whether this render system has hardware filtering supported for the texture format requested with the given usage options.

Not all texture format are supports filtering by the hardware, i.e. some cards support floating point format, but it doesn't supports filtering on the floating point texture at all, or only a subset floating point formats have flitering supported.

  In the case you want to write shader to work with floating point texture, and you want to produce better visual quality, it's necessary to flitering the texture manually in shader (potential requires four or more texture fetch instructions, plus several arithmetic instructions) if filtering doesn't supported by hardware. But in case on the hardware that supports floating point filtering natively, it had better to adopt this capability for performance (because only one texture fetch instruction are required) and doesn't loss visual quality.

  This method allow you queries hardware texture filtering capability to deciding which version of the shader to be used. Note it's up to you to write multi-version shaders for support various hardware, internal engine can't do that for you automatically.

Note
  Under GL, texture filtering are always supported by driver, but if it's not supported by hardware natively, software simulation will be used, and you will end up with very slow speed (less than 0.1 fps for example). To slove this performance problem, you must disable filtering manually (by use filtering none in the material script's texture_unit section, or call TextureUnitState::setTextureFiltering with TFO_NONE if populate material in code).

Parameters

  ttype | The texture type requested
  format | The pixel format requested
  usage | The kind of usage this texture is intended for, a combination of the TextureUsage flags.
  preciseFormatOnly | Whether precise or fallback format mode is used to detecting. In case the pixel format doesn't supported by device, false will be returned if in precise mode, and natively used pixel format will be actually use to check if in fallback mode.

Returns
  true if the texture filtering is supported.

Reimplemented in Ogre::DefaultTextureManager.

## ◆ setDefaultNumMipmaps()

virtual void Ogre::TextureManager::setDefaultNumMipmaps | ( | uint32 | num | ) |
| virtual

Sets the default number of mipmaps to be used for loaded textures, for when textures are loaded automatically (e.g.

by Material class) or when 'load' is called with the default parameters by the application. If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.

Note
  The default value is 0.

## ◆ getDefaultNumMipmaps()

virtual uint32 Ogre::TextureManager::getDefaultNumMipmaps | ( |  | ) |
| inlinevirtual

Gets the default number of mipmaps to be used for loaded textures.

## ◆ _getWarningTexture()

const TexturePtr & Ogre::TextureManager::_getWarningTexture | ( |  | ) |

Internal method to create a warning texture (bound when a texture unit is blank).

## ◆ getDefaultSampler()

const SamplerPtr & Ogre::TextureManager::getDefaultSampler | ( |  | ) |

get the default sampler

## ◆ getSingleton()

TextureManager & Ogre::TextureManager::getSingleton | ( | void |  | ) |
| static

Get the singleton instance.

References TextureManager().

## ◆ getSingletonPtr()

TextureManager * Ogre::TextureManager::getSingletonPtr | ( | void |  | ) |
| static

Get the singleton instance.

References TextureManager().

## ◆ createOrRetrieve() [2/2]

ResourceCreateOrRetrieveResult Ogre::ResourceManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )

Create a new resource, or retrieve an existing one with the same name if it already exists.

This method performs the same task as calling getByName() followed by create() if that returns null. The advantage is that it does it in one call so there are no race conditions if using multiple threads that could cause getByName() to return null, but create() to fail because another thread created a resource in between.

Parameters

  name | The unique name of the Resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs

Returns
  A pair, the first element being the pointer, and the second being an indicator specifying whether the resource was newly created.

The documentation for this class was generated from the following file:

- OgreTextureManager.h